<?

   // ------------------------------------------------------------------------------------------------
	function CreateCategoryPath($Path, $LastPosition=0, $LastIcon="") {
		$CategoryList = explode('.',$Path);
		$ParentId = 0;
		foreach ($CategoryList as $Idx=>$Category) {
		   if ($Idx == count($CategoryList)-1) {
				$ParentId = CreateCategory ($Category, $ParentId, $LastPosition, $LastIcon);
			} else {
				$ParentId = CreateCategory ($Category, $ParentId, false, false);
			}
		}
		return $ParentId;
	}


   // ------------------------------------------------------------------------------------------------
	function CreateCategory ($Name, $Parent, $Position, $Icon=null) {
	   $CategoryId = @IPS_GetCategoryIDByName($Name, $Parent);
	   if ($CategoryId === false) {
 			$CategoryId = IPS_CreateCategory();
   		IPS_SetName($CategoryId, $Name);
   		IPS_SetParent($CategoryId, $Parent);
   		if ($Position!==false) {
   			IPS_SetPosition($CategoryId, $Position);
			}
   		if ($Icon!==false) {
	   		IPS_SetIcon($CategoryId, $Icon);
			}
			echo 'Created Category '.$Name.'='.$CategoryId."\n";
	   }
		UpdateObjectData($CategoryId, $Position, $Icon);
		return $CategoryId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateInstance ($Name, $ParentId, $ModulId, $Position=0) {
		$InstanceId = @IPS_GetInstanceIDByName($Name, $ParentId);
		if ($InstanceId === false) {
			$InstanceId	= IPS_CreateInstance($ModulId);
			IPS_SetName($InstanceId, $Name);
			IPS_SetParent($InstanceId, $ParentId);
   		IPS_SetPosition($InstanceId, $Position);
			echo "Created Instance $Name=$InstanceId, ModuleID=$ModulId\n";
		}
		UpdateObjectData($InstanceId, $Position);
		return $InstanceId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateDummyInstance ($Name, $ParentId, $Position=0) {
	   return CreateInstance ($Name, $ParentId, "{485D0419-BE97-4548-AA9C-C083EB82E61E}", $Position);
	}

   // ------------------------------------------------------------------------------------------------
	function CreateScript ($Name, $File, $Parent, $Position=0) {
		$ScriptId = @IPS_GetScriptIDByName($Name, $Parent);
		if ($ScriptId ===false) {
			$ScriptId = IPS_CreateScript(0);
   		IPS_SetName($ScriptId, $Name);
 			IPS_SetScriptFile($ScriptId, $File);
			IPS_SetParent($ScriptId, $Parent);
   		IPS_SetPosition($ScriptId, $Position);
			echo 'Created Script '.$Name.'='.$ScriptId."\n";
		}
		UpdateObjectData($ScriptId, $Position);
		return $ScriptId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateVariable ($Name, $Type, $Parent, $Position, $Profile, $Action=null, $ValueDefault=null, $Icon="") {
	   $VariableId = @IPS_GetVariableIDByName($Name, $Parent);
	   if ($VariableId === false) {
 			$VariableId = IPS_CreateVariable($Type);
   		IPS_SetName($VariableId, $Name);
   		IPS_SetParent($VariableId, $Parent);
   		IPS_SetPosition($VariableId, $Position);
  			IPS_SetVariableCustomProfile($VariableId, $Profile);
 			IPS_SetVariableCustomAction($VariableId, $Action);
   		IPS_SetIcon($VariableId, $Icon);
			SetValue($VariableId, $ValueDefault);
			echo 'Created VariableId '.$Name.'='.$VariableId."\n";
		}
		$VariableData = IPS_GetVariable ($VariableId);
		if ($VariableData['VariableCustomProfile'] <> $Profile) {
			echo "Set VariableProfile='$Profile' for Variable='$Name' \n";
  			IPS_SetVariableCustomProfile($VariableId, $Profile);
		}
		if ($VariableData['VariableCustomAction'] <> $Action) {
			echo "Set VariableCustomAction='$Action' for Variable='$Name' \n";
 			IPS_SetVariableCustomAction($VariableId, $Action);
		}
		UpdateObjectData($VariableId, $Position, $Icon);
		return $VariableId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateLink ($Name, $Link, $Parent, $Position) {
	   $LinkId = @IPS_GetLinkIDByName($Name, $Parent);
	   if ($LinkId === false) {
 			$LinkId = IPS_CreateLink();
   		IPS_SetName($LinkId, $Name);
			IPS_SetLinkChildID($LinkId, $Link);
   		IPS_SetParent($LinkId, $Parent);
   		IPS_SetPosition($LinkId, $Position);
			echo 'Created Link '.$Name.'='.$LinkId."\n";
	   }
		UpdateObjectData($LinkId, $Position);
		IPS_SetLinkChildID($LinkId, $Link);
		return $LinkId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateLinkByDestination ($Name, $LinkChildId, $Parent, $Position) {
	   $LinkId    = false;
		$ObjectIds = IPS_GetChildrenIDs ($Parent);
		foreach ($ObjectIds as $ObjectId) {
			$Object = IPS_GetObject ($ObjectId);
			if ($Object['ObjectType']==6 /*Link*/) {
				$Link = IPS_GetLink($ObjectId);
			   if ($Link['LinkChildID']==$LinkChildId) {
			      $LinkId = $ObjectId;
					break;
			   }
			}
		}

	   if ($LinkId === false) {
 			$LinkId = IPS_CreateLink();
   		IPS_SetParent($LinkId, $Parent);
	  		IPS_SetPosition($LinkId, $Position);
	   }
		IPS_SetLinkChildID($LinkId, $LinkChildId);
  		IPS_SetName($LinkId, $Name);
		UpdateObjectData($LinkId, $Position);
		return $LinkId;
	}

   // ------------------------------------------------------------------------------------------------
	function UpdateObjectData($ObjectId, $Position, $Icon="") {
		$ObjectData = IPS_GetObject ($ObjectId);
	   $ObjectPath = IPS_GetLocation($ObjectId);
		if ($ObjectData['ObjectPosition'] <> $Position and $Position!==false) {
			echo "Set ObjectPosition='$Position' for Object='$ObjectPath' \n";
   		IPS_SetPosition($ObjectId, $Position);
		}
		if ($ObjectData['ObjectIcon'] <> $Icon and $Icon!==false) {
			echo "Set ObjectIcon='$Icon' for Object='$ObjectPath' \n";
   		IPS_SetIcon($ObjectId, $Icon);
		}

	}


   // ------------------------------------------------------------------------------------------------
   // Constant Definitions
   // ------------------------------------------------------------------------------------------------
	function SetVariableConstant ($Name, $ID, $FileName) {
	   $FileNameFull = IPS_GetKernelDir().'scripts/'.$FileName;
   	$FileContent = file_get_contents($FileNameFull, true);

		$pos = strpos($FileContent, $Name);
		if ($pos === false) {
		  echo "Error - ".$Name." could NOT be found in FileContent!\n";
		}
		$pos = $pos + strlen($Name);
		while (substr($FileContent, $pos, 1) < "0" or substr($FileContent, $pos, 1) > "9") {
			$pos = $pos+1;
		}
		$FileContentNew = substr($FileContent, 0, $pos).$ID.substr($FileContent, $pos+5);

   	file_put_contents($FileNameFull, $FileContentNew);
	}

   // ------------------------------------------------------------------------------------------------
   // Timer Definitions
   // ------------------------------------------------------------------------------------------------
	function CreateTimer_OnceADay ($Name, $Parent, $Hour, $Minute=0) {
	   $TimerId = @IPS_GetEventIDByName($Name, $Parent);
	   if ($TimerId === false) {
 			$TimerId = IPS_CreateEvent(1 /*Cyclic Event*/);
   		IPS_SetName($TimerId, $Name);
   		IPS_SetParent($TimerId, $Parent);
			if (!IPS_SetEventCyclic($TimerId, 2 /**Daily*/, 1,0,0,0,0)) {
				echo "IPS_SetEventCyclic failed !!!\n";
				exit;
			}
			if (!IPS_SetEventCyclicTimeBounds($TimerId, mktime($Hour, $Minute, 0), 0)) {
				echo "IPS_SetEventCyclicTimeBounds failed !!!\n";
				exit;
			}
   		IPS_SetEventActive($TimerId, true);
			echo 'Created Timer '.$Name.'='.$TimerId."\n";
		}
		return $TimerId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateTimer_CyclicBySeconds ($Name, $Parent, $Seconds, $Active=true) {
	   $TimerId = @IPS_GetEventIDByName($Name, $Parent);
	   if ($TimerId === false) {
 			$TimerId = IPS_CreateEvent(1 /*Cyclic Event*/);
   		IPS_SetName($TimerId, $Name);
   		IPS_SetParent($TimerId, $Parent);
			if (!IPS_SetEventCyclic($TimerId, 2 /*Daily*/, 1 /*Int*/,0 /*Days*/,0/*DayInt*/,1/*TimeType Sec*/,$Seconds/*Sec*/)) {
				echo "IPS_SetEventCyclic failed !!!\n";
				exit;
			}
   		IPS_SetEventActive($TimerId, $Active);
			echo 'Created Timer '.$Name.'='.$TimerId."\n";
		}
		return $TimerId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateTimer_CyclicByMinutes ($Name, $Parent, $Minutes, $Active=true) {
	   $TimerId = @IPS_GetEventIDByName($Name, $Parent);
	   if ($TimerId === false) {
 			$TimerId = IPS_CreateEvent(1 /*Cyclic Event*/);
   		IPS_SetName($TimerId, $Name);
   		IPS_SetParent($TimerId, $Parent);
			if (!IPS_SetEventCyclic($TimerId, 2 /*Daily*/, 1 /*Unused*/,0 /*Unused*/,0/*Unused*/,2/*TimeType Minutes*/,$Minutes/*Minutes*/)) {
				echo "IPS_SetEventCyclic failed !!!\n";
				exit;
			}
   		IPS_SetEventActive($TimerId, $Active);
			echo 'Created Timer '.$Name.'='.$TimerId."\n";
		}
		return $TimerId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateEvent ($Name, $VariableId, $ScriptId, $TriggerType=1/*ByChange*/) {
		$EventId = @IPS_GetEventIDByName ($Name,$ScriptId);
	   if ($EventId===false) {
			$EventId = IPS_CreateEvent(0);
	  		IPS_SetName($EventId, $Name);
			IPS_SetEventTrigger($EventId, $TriggerType, $VariableId);
			IPS_SetParent($EventId, $ScriptId);
			IPS_SetEventActive($EventId, true);
			echo "Created Event $Name=$EventId, trigger ScriptId=$ScriptId by Variable=$VariableId\n";
  		}
		return $EventId;
	}

   // ------------------------------------------------------------------------------------------------
   // Instance Definitions
   // ------------------------------------------------------------------------------------------------
	function CreateMediaPlayer($Name, $ParentId, $Position=0) {
		$MediaPlayerInstanceId = CreateInstance($Name, $ParentId, "{2999EBBB-5D36-407E-A52B-E9142A45F19C}",$Position);
		$SoundCards = WAC_GetDevices($MediaPlayerInstanceId);
		foreach ($SoundCards as $Idx=>$SoundCard) {
			if ($SoundCard <> "No sound") {
				echo "Set Soundcard $SoundCard\n";
			   WAC_SetDeviceID($MediaPlayerInstanceId, $Idx);
			}
		}
		WAC_SetUpdateInterval($MediaPlayerInstanceId, 1);
		IPS_ApplyChanges($MediaPlayerInstanceId);
		
		return $MediaPlayerInstanceId;
	}

   // ------------------------------------------------------------------------------------------------
   // Profile Definitions
   // ------------------------------------------------------------------------------------------------
	function CreateProfile_Associations ($Name, $Associations, $Icon="", $Color=0xaaaaaa, $DeleteProfile=true) {
		if ($DeleteProfile) {
			@IPS_DeleteVariableProfile($Name);
		}
		@IPS_CreateVariableProfile($Name, 1);
		IPS_SetVariableProfileText($Name, "", "");
		IPS_SetVariableProfileValues($Name, 0, 0, 0);
		IPS_SetVariableProfileDigits($Name, 0);
		IPS_SetVariableProfileIcon($Name, $Icon);
		foreach($Associations as $Idx => $IdxName) {
		   if (is_array($Color)) {
				IPS_SetVariableProfileAssociation($Name, $Idx, $IdxName, "", $Color[$Idx]);
		   } else {
				IPS_SetVariableProfileAssociation($Name, $Idx, $IdxName, "", $Color);
			}
		}
	}


   // ------------------------------------------------------------------------------------------------
	function CreateProfile_Switch ($Name, $DisplayFalse, $DisplayTrue, $Icon="", $ColorOff=0xaaaaaa, $ColorOn=0x00ff00, $IconOff="", $IconOn="") {
		@IPS_CreateVariableProfile($Name, 1);
		IPS_SetVariableProfileText($Name, "", "");
		IPS_SetVariableProfileValues($Name, 0, 1, 1);
		IPS_SetVariableProfileDigits($Name, 0);
		IPS_SetVariableProfileIcon($Name, $Icon);
		IPS_SetVariableProfileAssociation($Name, 0, $DisplayFalse, $IconOff, $ColorOff);
		IPS_SetVariableProfileAssociation($Name, 1, $DisplayTrue,  $IconOn,  $ColorOn);
	}

   // ------------------------------------------------------------------------------------------------
	function CreateProfile_Count ($Name, $Start=0, $Step=0, $Stop=0, $Prefix="", $Suffix="", $Icon="") {
		@IPS_CreateVariableProfile($Name, 1);
		IPS_SetVariableProfileText($Name, $Prefix, $Suffix);
		IPS_SetVariableProfileValues($Name, $Start, $Stop, $Step);
		IPS_SetVariableProfileDigits($Name, 0);
		IPS_SetVariableProfileIcon($Name, $Icon);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ObjectIDByPath($Path) {
		$CategoryList = explode('.',$Path);
		$ObjId = 0;
		foreach ($CategoryList as $Idx=>$Category) {
		   $ObjId = IPS_GetObjectIDByName($Category, $ObjId);
		   if ($ObjId==null) die("'$Category' could NOT be found !!!");
		}
		return $ObjId;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function exists_WFCItem($WFCId, $ItemId) {
	   $ItemList = WFC_GetItems($WFCId);
	   foreach ($ItemList as $Item) {
	      if ($Item['ID']==$ItemId) {
				return true;
	      }
	   }
	   return false;
	}

	//$ItemList = WFC_GetItems(57215);
	//print_r($ItemList);

	// ----------------------------------------------------------------------------------------------------------------------------
	function PrepareWFCItemData ($ItemId, $ParentId, $Title) {
		$ItemId   = str_replace(' ','_',$ItemId);
		$ParentId = str_replace(' ','_',$ParentId);
		$ItemId   = str_replace('_','',$ItemId);
		$ParentId = str_replace('_','',$ParentId);
		$Title    = utf8_encode($Title);
		$ItemId   = utf8_encode($ItemId);
		$ParentId = utf8_encode($ParentId);
	}
	
	// ----------------------------------------------------------------------------------------------------------------------------
	function CreateWFCItem ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon, $ClassName, $Configuration) {
	   if (!exists_WFCItem($WFCId, $ItemId)) {
		   echo "Add WFCItem='$ItemId', Class=$ClassName, Config=$Configuration\n";
			WFC_AddItem($WFCId, $ItemId, $ClassName, $Configuration, $ParentId);
		}
		WFC_UpdateConfiguration($WFCId, $ItemId, $Configuration);
		WFC_UpdateParentID($WFCId, $ItemId, $ParentId);
		WFC_UpdatePosition($WFCId,$ItemId, $Position);
		IPS_ApplyChanges($WFCId);
	}


	// ----------------------------------------------------------------------------------------------------------------------------
	function CreateWFCItemTabPane ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon) {
      PrepareWFCItemData (&$ItemId, &$ParentId, &$Title);
	   $Configuration = "{\"title\":\"$Title\",\"name\":\"$ItemId\",\"icon\":\"$Icon\"}";
      CreateWFCItem ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon, 'TabPane', $Configuration);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function CreateWFCItemSplitPane ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon="", $Alignment=0 /*0=horizontal, 1=vertical*/, $Ratio=50, $RatioTarget=0 /*0 or 1*/, $RatioType /*0=Percentage, 1=Pixel*/, $ShowBorder='true' /*'true' or 'false'*/) {
      PrepareWFCItemData (&$ItemId, &$ParentId, &$Title);
	   $Configuration = "{\"title\":\"$Title\",\"name\":\"$ItemId\",\"icon\":\"$Icon\",\"alignmentType\":$Alignment,\"ratio\":$Ratio,\"ratioTarget\":$RatioTarget,\"ratioType\":$RatioType,\"showBorder\":$ShowBorder}";
      CreateWFCItem ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon, 'SplitPane', $Configuration);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function CreateWFCItemCategory ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon="", $BaseId /*ID of Category*/, $BarBottomVisible='true' /*'true' or 'false'*/, $BarColums=9, $BarSteps=5, $PercentageSlider='true' /*'true' or 'false'*/ ) {
      PrepareWFCItemData (&$ItemId, &$ParentId, &$Title);
	   $Configuration = "{\"title\":\"$Title\",\"name\":\"$ItemId\",\"icon\":\"$Icon\",\"baseID\":$BaseId,\"enumBarColumns\":$BarColums,\"selectorBarSteps\":$BarSteps,\"isBarBottomVisible\":$BarBottomVisible,\"enablePercentageSlider\":$PercentageSlider}";
      CreateWFCItem ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon, 'Category', $Configuration);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function CreateWFCItemExternalPage ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon="", $PageUri, $BarBottomVisible='true' /*'true' or 'false'*/) {
      PrepareWFCItemData (&$ItemId, &$ParentId, &$Title);
	   $Configuration = "{\"title\":\"$Title\",\"name\":\"$ItemId\",\"icon\":\"$Icon\",\"pageUri\":\"$PageUri\",\"isBarBottomVisible\":$BarBottomVisible}";
      CreateWFCItem ($WFCId, $ItemId, $ParentId, $Position, $Title, $Icon, 'ExternalPage', $Configuration);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function DeleteWFCItems($WFCId, $ItemId) {
	   $ItemList = WFC_GetItems($WFCId);
	   foreach ($ItemList as $Item) {
	      if (strpos($Item['ID'], $ItemId)===0) {
	   		//echo "Found WFC Item='".$Item['ID']."', Parent='".$Item['ParentID']."'\n";
				WFC_DeleteItem($WFCId, $Item['ID']);
	      }
	   }
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function DeleteWFCItem($WFCId, $ItemId) {
	   echo "Delete WFC Item='$ItemId'\n";
		WFC_DeleteItem($WFCId, $ItemId);
	}
?>